/* This is a sample program that you can use to
 * test  your implementation of rec_string procedures.
 */
#include <stdio.h>
#include <string.h>

/*! reads one line from standard input and copies it to line array 
 * (but no more than max chars).
 * It does not place the terminating \n in line array.
 * Returns line length, or 0 for empty line, or EOF for end-of-file.
 */
int getline(char line[], int max)
{
  int nch = 0;
  int c;
  max--;			/* leave room for '\0' */

  while ((c = getchar()) != EOF) {
    if ((c == '\n') || (c == '\r'))
      break;

    if (nch >= max)
      break;
    line[nch++] = c;
  }

  if (c == EOF && nch == 0)
    return EOF;

  line[nch] = '\0';
  return nch;
}

#define MAX_STR 256
/*! main */
int main(void)
{
  char str[MAX_STR], name[MAX_STR];
  int n;
  strcpy(str, "Hello, dear");

  if ((n = getline(name, MAX_STR)) == EOF) {
    printf("ERROR: empty input.\n");
    return 0;
  }
  if (n != strlen(name)) {
    printf("ERROR: your strlen must be wrong! it should return %d.\n", n);
    return 0;
  }
  if (strlen(str) + n + 4 > MAX_STR) {
    printf("ERROR: input is too long!\n");
    return 0;
  }
  if (strcmp(name, "Queen Elizabeth") == 0) {
    printf("ERROR: you must be kidding!\n");
  }
  if (strcmp(name, "z") > 0) {
    printf("ERROR: does your name start with \'z\'?\n");
  }
  strcat(str, " ");
  strcat(str, name);
  strcat(str, "!\n");
  printf(str);
  return 0;
}
